
;******************************** 48 MODE ROUTINES *******************************

STORER_:		LDI		ZH,0X80				; 
				LDI		ZL,0X00				; 
				CBI		PORTC,7				; 1 RESET 
				SBI		DDRC,7				; 1 A15
				LDI		BUF,1<<XMM0			; 3 RELEASE
				STS		XMCRB,BUF			; 3 PC7
				IN		BUF,I				; 
				IN		TMPH,IXH			; 
				IN		TMPL,IXL			; 
				XON_RBBCP					; ON XMEM
				ST		Z+,PCL				; 
				ST		Z+,PCH				; 
				ST		Z+,C				; 
				ST		Z+,B				; 
				ST		Z+,E				; 
				ST		Z+,D				; 
				ST		Z+,L				; 
				ST		Z+,H				; 
				ST		Z+,F				; 
				ST		Z+,RES				;
				ST		Z+,A				; 
				ST		Z+,BUF				; 
				ST		Z+,R				; 
				ST		Z+,TMPL				;
				ST		Z+,TMPH				;
				IN		TMPH,IYH			; 
				IN		TMPL,IYL			; 	
				ST		Z+,STPL				; 
				ST		Z+,STPH				; 
				ST		Z+,_C				; 
				ST		Z+,_B				; 
				ST		Z+,_E				; 
				ST		Z+,_D				; 
				ST		Z+,_L				; 
				ST		Z+,_H				; 
				IN		BUF,_F				;
				ST		Z+,BUF				; 
				IN		BUF,_RES			; 
				ST		Z+,BUF				; 
				MOV		BUF,_A				;
				ST		Z+,BUF				; 
				ST		Z+,TMPL				; 
				ST		Z+,TMPH				; 
				IN		TMPH,MEMPTRH		; 
				IN		TMPL,MEMPTRL		; 
				ST		Z+,TMPL				; 
				ST		Z+,TMPH				; 
				IN		BUF,CONTROL			; 
				ST		Z+,BUF				; 
				IN		BUF,ACSR			; 
				ST		Z+,BUF				; 
				IN		BUF,PINB			; 
				ST		Z+,BUF				; 
				IN		BUF,PIND			; 
				ST		Z,BUF				; 
				LDI		ZL,0XFF				; 
				LDI		BUF,128				; 
				ST		Z,BUF				; STORE MODE MARKER
				NOP							; OFF
				XOFF_RBBCP					; XMEM
				CBI		DDRC,7				; 2 A15 AS INPUT
				STS		XMCRB,ZERO			; 2 PC7 AS A15
				CBI		PORTD,TOVCPU		; GENERANE VIDEOCPU REQUEST
WFA1:			SBIC	PIND,TOCPU			; WAIT FOR ANSWER
				RJMP	WFA1				; 
				SBI		PORTD,TOVCPU		; CLEAR REQUEST
WFA2:			SBIS	PIND,TOCPU			; WAIT FOR 
				RJMP	WFA2				; OPERATION COMPLETE
M11:			JMP		M1					; RETURN TO M1


LOADER_:		CBI		PORTC,7				; 1 RESET 
				SBI		DDRC,7				; 1 A15
				LDI		BUF,1<<XMM0			; 1 RELEASE
				STS		XMCRB,BUF			; 1 PC7
				LDI		ZH,0X80				; 1 LOADER MARKER
				LDI		ZL,0XFF				; 1 ADDRESS
				LDI		BUF,0X02			; 
				XON_RBBCP					; ENABLE XMEM
				ST		Z,BUF				; LOADER MARKER = 2
				XOFF_RBBCP					; DISABLE XMEM
				CBI		DDRC,7				; A15 AS INPUT
				CBI		PORTD,TOVCPU		; GENERANE VIDEOCPU REQUEST
WFVCPUANS3:		SBIC	PIND,TOCPU			; WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS3			; ANSWER
				SBI		PORTD,TOVCPU		; OFF VIDEOCPU REQUEST
WFVCPUANS4:		SBIS	PIND,TOCPU			; WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS4			; LOAD OPERATION COMPLETE
				SBI		DDRC,7				; A15 AS OUTPUT
				LDI		ZL,0X00				; ADDRESS OF DATA BEGIN
				XON_RBBCP					; ON XMEM
				LD		PCL,Z+				; 
				LD		PCH,Z+				; 
				LD		C,Z+				; 
				LD		B,Z+				; 
				LD		E,Z+				; 
				LD		D,Z+				; 
				LD		L,Z+				; 
				LD		H,Z+				;
				LD		F,Z+				; 
				LD		RES,Z+				; 
				LD		A,Z+				; 
				LD		BUF,Z+				; 
				OUT		I,BUF				; 
				LD		R,Z+				; 
				LD		TMPL,Z+				; 
				LD		TMPH,Z+				; 
				OUT		IXH,TMPH			; 
				OUT		IXL,TMPL			; 	
				LD		STPL,Z+				; 
				LD		STPH,Z+				; 
				LD		_C,Z+				; 
				LD		_B,Z+				; 
				LD		_E,Z+				; 
				LD		_D,Z+				; 
				LD		_L,Z+				; 
				LD		_H,Z+				; 
				LD		BUF,Z+				; 
				OUT		_F,BUF
				LD		BUF,Z+				; 
				OUT		_RES,BUF			; 
				LD		BUF,Z+				; 
				OUT		_A,BUF				;
				LD		TMPL,Z+				; 
				LD		TMPH,Z+				; 
				OUT		IYL,TMPL			; 
				OUT		IYH,TMPH			; 
				LD		TMPL,Z+				; 
				LD		TMPH,Z+				; 
				OUT		MEMPTRL,TMPL		; 
				OUT		MEMPTRH,TMPH		; 
				LD		BUF,Z+				; 
				OUT		CONTROL,BUF			; 
				LD		BUF,Z+				; 
				OUT		ACSR,BUF			; 
				LD		BUF,Z+				; 
				OUT		PORTB,BUF			; 
				LD		BUF,Z				; 
				OUT		PORTD,BUF			; 
				NOP							; OFF
				XOFF_RBBCP					; XMEM
				CBI		DDRC,7				; 1 A15 AS INPUT
				STS		XMCRB,ZERO			; 2 PC7 AS A15
 				SBI		ACSR,ACI			; RESET AC FLAG 
				RJMP	M1					; 


DISASM_TABLE:	SBI		PORTD,A16				; ^ 1 SET A16               ^^^^^^^^ LOADING DISASM TABLE ^^^^^^^^
				CBI		PORTC,7					; ^ 1 RESET 
				SBI		DDRC,7					; ^ 1 A15
				LDI		BUF,1<<XMM0				; ^ 1 RELEASE
				STS		XMCRB,BUF				; ^ 1 PC7
				LDI		ZH,0X80					; ^ 1 LOADER MARKER
				LDI		ZL,0XFF					; ^ 1 ADDRESS
				LDI		BUF,0X02				; ^
				XON_RBBCP						; ^ ENABLE XMEM
				ST		Z,BUF					; ^ LOADER MARKER = 2
				XOFF_RBBCP						; ^ DISABLE XMEM
				CBI		DDRC,7					; ^ A15 AS INPUT
				CBI		PORTD,TOVCPU			; ^ GENERANE VIDEOCPU REQUEST
WFVCPUANS5:		SBIC	PIND,TOCPU				; ^ WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS5				; ^ ANSWER
				SBI		PORTD,TOVCPU			; ^ OFF VIDEOCPU REQUEST
WFVCPUANS6:		SBIS	PIND,TOCPU				; ^ WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS6				; ^ LOAD OPERATION COMPLETE
				STS		XMCRB,ZERO				; ^ 2 PC7 AS A15
				CBI		PORTD,A16				; ^ 1 RESET A16
				RET								; RETURN TO MAIN PROGRAMM
















