
;********************** DESCRIPTION ********************************
; CONTROL:
; 7 IFF2
; 6 IFF1
; 5 
; 4 IOM: IN/OUT MODE: 0 -NORMAL, 1 - INTERNAL AVR ADDRESS SPACE
; 3 R:7
; 2 IMH INTERRUPT MODE LOW BIT
; 1 IML INTERRUPT MODE HIGH BIT
; 0 
; 
; X-PAIR = PROGRAM COUNTER
; Y-PAIR = STACK POINTER (STPH:STPL)
; Z-PAIR = TEMPORARY POINTER
; 
;********************************************************************
.INCLUDE "m128def.inc"
.INCLUDE "REGDEF.inc"
.INCLUDE "MACROSES.inc"
.INCLUDE "TIMINGS.inc"

.ORG 0X0000
.INCLUDE "CROSSER.inc"
.INCLUDE "OPCODE_ED.inc"
.INCLUDE "OPCODE_MAIN.inc"
.INCLUDE "OPCODE_FD.inc"

.ORG 0X8000
;.INCLUDE "128.inc"
;.INCLUDE "2006.inc"
;.INCLUDE "ROM_FULL.inc"
;.INCLUDE "ATMTEST3.inc"
;.INCLUDE "KAY1024_LOW.inc"
.INCLUDE "PENTAGON.inc"
;.INCLUDE "PLUS2.inc"
;.INCLUDE "PROFI_LOW.inc"
;.INCLUDE "SERVICE.inc"
;.INCLUDE "SOS.inc"
;.INCLUDE "TK90.inc"
;.INCLUDE "TK95.inc"
;.INCLUDE "Zxi1.inc"
;.INCLUDE "ROM_TEST.inc"
;.INCLUDE "ROM_CRACKED.inc"


.INCLUDE "OPCODE_CB.inc"
.INCLUDE "OPCODE_DD.inc"
.INCLUDE "OPCODE_DDCB.inc"
















RESET:			CLI

				LDI		BUF,(1<<MUXA15)|(1<<MUXA14)			; 1 
				OUT		PORTB,BUF							; 1 PORTB 
				LDI		BUF,(1<<TOTAPE)|(1<<BEEP)|(1<<NBEEP)|(1<<MUXA17)|(1<<MUXA16)|(1<<MUXA15)|(1<<MUXA14); 1 CONFIGURATION
				OUT		DDRB,BUF							; 1 
		
				LDI		BUF,(1<<A14_CPU)					; 1 
				OUT		PORTC,BUF							; 1 PORTC 
				LDI		BUF,(1<<A15_CPU)|(1<<A14_CPU)		; 1 CONFIGURATION
				OUT		DDRC,BUF							; 1 
				
				LDI		BUF,(1<<TOVCPU)						; 2 
				OUT		PORTD,BUF							; 2 PORTD CONFIGURATION
				LDI		BUF,(1<<BORDERL)|(1<<BORDERM)|(1<<BORDERH)|(1<<BORDERY)|(1<<A16)|(1<<TOVCPU); 2 
				OUT		DDRD,BUF
											; 2 
				
				LDI		BUF,(1<<RBBCP)						; 2 
				OUT		PORTE,BUF							; 2 PORTE CONFIGURATION
				LDI		BUF,(1<<RBBCP)|(1<<SCRA16)			; 2 
				OUT		DDRE,BUF							; 2 
				
				LDI		BUF,(1<<KEYMH)|(1<<7);|(1<<5)		; 3 
				STS		PORTF,BUF							; 3 PORTF CONFIGURATION
				LDI		BUF,(1<<KEYMH)|(1<<7)|(1<<5)		; 3 
				STS		DDRF,BUF							; 3 
				
				LDI		BUF,0XFF							; 0 STEK POINTER
				OUT		SPL,BUF								; 0 INITIALISING
				LDI		BUF,0X10							; 0 STEK POINTER
				OUT		SPH,BUF								; 0 INITIALISING
				LDI		BUF,(1<<IVCE)						; 1 
				OUT		MCUCR,BUF							; 1 REMOVE VECTOR TABLE 
				LDI		BUF,(1<<IVSEL)						; 1 TO 0XFE00
				OUT		MCUCR,BUF							; 1 				
				
				LDI		BUF,1<<RAMPZ0						; 2 SET 
				OUT		RAMPZ,BUF							; 2 ROM PAGE 1	
				
				
				CLR		ZERO								; CLEAR ZERO REGISTER
				LDI		BUF,128								; 1 LOAD 
				MOV		CONST128,BUF						; 1 CONST128 REGISTER
				LDI		BUF,0X01							; 2 LOAD
				MOV		ONE,BUF								; 2 ONE REGISTER
				LDI		BUF,0X00;01<<ROMIDBIT				; 2 LOAD
				MOV		ROMID,BUF							; 2 ROMID REGISTER
				
				LDI		B,0XFF					; 
				LDI		C,0XFF					; 
				MOVW	E,C						;
				MOVW	L,C						;
				MOVW	A,C						;
				MOVW	_C,C					;
				OUT		_D,C					;
				OUT		_E,C					;
				OUT		_H,C					;
				OUT		_L,C					;
				OUT		_A,C					;
				OUT		_F,C					;
				MOV		IXH,C					;
				MOV		IXL,C					;
				MOV		IYH,C					;
				MOV		IYL,C					;	
				
				MOV		MEMPTRL,ZERO			; 
				MOV		MEMPTRH,ZERO			; 
				STS		ADDR3,ZERO				; 
				STS		ADDR2,ZERO				; 
				STS		ADDR1,ZERO				; 
				LDI		ZH,0X07					;
				LDI		ZL,0X00					; 
				ST		Z,ZERO					; CLEAR BYTE-COUNTER OF LICENSE CODE GENERATOR (ADDRESS 0X0700)

				LDI		BUF,(1<<ADLAR)|(1<<MUX2)|(1<<MUX1)|(1<<REFS0)	; % SET EXTERNAL REF, LEFT ADJUSTMENT, 
				OUT		ADMUX,BUF										; % ADC6 CHANNEL
				LDI		BUF,(1<<ADEN)|(1<<ADFR)|(1<<ADSC)|(1<<ADPS1)	; % ON AD CONVERTER IN FREE-RUNNING MODE
				OUT		ADCSRA,BUF										; % WITH PRESCALING FACTOR 2

				;LDI		BUF,3					; 
				;STS		OCR3AH,ZERO				; 
				;STS		OCR3AL,BUF				; 
				;LDI		BUF,1<<OCIE3A			; 
				;STS		ETIMSK,BUF				; 



				LDI		BUF,(1<<SYS)			; 
				OUT		CONTROL,BUF				; INTERUPT DISABLED, INTERUPT MODE 0, SYSTEM HAS STARTED
				MOV		R,ZERO					; CLEAR REGENERATION REGISTER
				OUT		I,ZERO					; CLEAR INDEX REGISTER
				LDI		PCH,0X00				; RESET
				LDI		PCL,0X00                ; PROGRAM COUNTER

TAB16:			LDI		ZH,0X08
				LDI		ZL,0X00
				LDI		BUF,0X45					; 0
				ST		Z+,BUF
				LDI		BUF,0X16					; 1
				ST		Z+,BUF
				LDI		BUF,0X1E					; 2
				ST		Z+,BUF
				LDI		BUF,0X26					; 3
				ST		Z+,BUF
				LDI		BUF,0X25					; 4
				ST		Z+,BUF
				LDI		BUF,0X2E					; 5
				ST		Z+,BUF
				LDI		BUF,0X36					; 6
				ST		Z+,BUF
				LDI		BUF,0X3D					; 7
				ST		Z+,BUF
				LDI		BUF,0X3E					; 8
				ST		Z+,BUF
				LDI		BUF,0X46					; 9
				ST		Z+,BUF
				LDI		BUF,0X1C					; A
				ST		Z+,BUF
				LDI		BUF,0X32					; B
				ST		Z+,BUF
				LDI		BUF,0X21					; C
				ST		Z+,BUF
				LDI		BUF,0X23					; D
				ST		Z+,BUF
				LDI		BUF,0X24					; E
				ST		Z+,BUF
				LDI		BUF,0X2B					; F
				ST		Z+,BUF


				LDI		ZH,0X0B
				CLR		ZL
				LDI		TMPH,0X00
				ST		Z,TMPH


				;CALL	DISASM_TABLE			; LOAD DISASSEMBLER TABLE

				LDI		ZL,0X00					; **
				LDI		ZH,0X01					; ** FIRST PARITY TABLE (WITH Z FLAG)
				LDI		TMPH,1<<PP				; **
PM1:			LDI		BUF,0X08				; **
				MOV		ZERO,BUF				; **
				LDI		BUF,1<<PP				; **
				MOV		TMPL,ZL					; **	
BITLPTP:		SBRC	TMPL,7					; **
				EOR		BUF,TMPH				; **
				LSL		TMPL					; **
				DEC		ZERO					; **
				BRNE	BITLPTP					; **
				ST		Z,BUF					; **
				LDI		ZH,0X05					; ** THURD PARITY TABLE (WITHOUT Z FLAG AND H FLAGS)
				ST		Z,BUF					; **
				LDI		ZH,0X03					; ** SECOND PARITY TABLE (WITH Z FLAG AND H SET)
				SBR		BUF,1<<HH				; **
				ST		Z+,BUF					; **
				LDI		ZH,0X01					; ** FIRST PARITY TABLE (WITH Z FLAG)
				CP		ZL,ZERO					; **
				BRNE	PM1    					; ** 
				LDI		BUF,(1<<ZZ)|(1<<PP)		; ** 
				ST		Z,BUF					; ** 
				LDI		ZH,0X03					; ** SECOND PARITY TABLE (WITH Z FLAG AND H SET)
				LDI		BUF,(1<<ZZ)|(1<<PP)|(1<<HH); **
				ST		Z,BUF					; ** 
				LDI		ZH,0X05					; ** THURD PARITY TABLE (WITHOUT Z FLAG AND H FLAGS)
				LDI		BUF,(1<<PP)				; **
				ST		Z,BUF					; ** 
				
				LDI		ZH,HIGH(PAGETBL)					; # 
				LDI		ZL,0X00								; # 
PGTBLFILLLOOP:	MOV		BUF,ZL								; # 
				CBR		BUF,0B11111000						; # 
				CPI		BUF,0X00							; # 
				BRNE	PAGENOT0							; # 
				LDI		BUF,(1<<MUXA15)|(1<<MUXA14)			; # 
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT0:		CPI		BUF,0X01							; # 
				BRNE	PAGENOT1							; # 
				LDI		BUF,(1<<MUXA16)|(1<<MUXA14)			; # 
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT1:		CPI		BUF,0X02							; # 
				BRNE	PAGENOT2							; # 
				LDI		BUF,(1<<MUXA15)						; # 
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT2:		CPI		BUF,0X03							; # 
				BRNE	PAGENOT3							; # 
				LDI		BUF,(1<<MUXA16)						; # 				
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT3:		CPI		BUF,0X04							; # 
				BRNE	PAGENOT4							; # 
				LDI		BUF,(1<<MUXA16)|(1<<MUXA15)			; # 
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT4:		CPI		BUF,0X05							; # 
				BRNE	PAGENOT5							; # 
				LDI		BUF,(1<<MUXA14)						; # 
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT5:		CPI		BUF,0X06							; # 
				BRNE	PAGENOT6							; # 
				LDI		BUF,(1<<MUXA16)|(1<<MUXA15)|(1<<MUXA14); # 
				ST		Z+,BUF								; # 
				RJMP	COMPGTBLFILL						; # 
PAGENOT6:		LDI		BUF,0X00							; # 
				ST		Z+,BUF								; # 
COMPGTBLFILL:	CPI		ZL,0X00								; # 
				BRNE	PGTBLFILLLOOP						; # 

				LDI		ZH,0X0B
				CLR		ZL
				LDI		BUF,0X00
				ST		Z,BUF




DONEM3:			RJMP	DONEM2;1				; -3, -2

DONEM80:		NOP								;                                 -80
DONEM79:		NOP								;                                 -79
DONEM78:		NOP								;                                 -78
DONEM77:		NOP								;                                 -77
DONEM76:		NOP								;                                 -76
DONEM75:		NOP								;                                 -75
DONEM74:		NOP								;                                 -74
DONEM73:		NOP								;                                 -73
DONEM72:		NOP								;                                 -72
DONEM71:		NOP								;                                 -71
DONEM70:		NOP								;                                 -70
DONEM69:		NOP								;                                 -69
DONEM68:		NOP								;                                 -68
DONEM67:		NOP								;                                 -67
DONEM66:		NOP								;                                 -66
DONEM65:		NOP								;                                 -65
DONEM64:		NOP								;                                 -64
DONEM63:		NOP								;                                 -63
DONEM62:		NOP								;                                 -62
DONEM61:		NOP								;                                 -61
DONEM60:		NOP								;                                 -60
DONEM59:		NOP								;                                 -59
DONEM58:		NOP								;                                 -58
DONEM57:		NOP								;                                 -57
DONEM56:		NOP								;                                 -56
DONEM55:		NOP								;                                 -55
DONEM54:		NOP								;                                 -54
DONEM53:		NOP								;                                 -53
DONEM52:		NOP								;                                 -52
DONEM51:		NOP								;                                 -51
DONEM50:		NOP								;                                 -50
DONEM49:		NOP								;                                 -49
DONEM48:		NOP								;                                 -48
DONEM47:		NOP								;                                 -47
DONEM46:		NOP								;                                 -46
DONEM45:		NOP								;                                 -45
DONEM44:		NOP								;                                 -44
DONEM43:		NOP								;                                 -43
DONEM42:		NOP								;                                 -42
DONEM41:		NOP								;                                 -41
DONEM40:		NOP								;                                 -40
DONEM39:		NOP								;                                 -39
DONEM38:		NOP								;                                 -38
DONEM37:		NOP								;                                 -37
DONEM36:		NOP								;                                 -36
DONEM35:		NOP								;                                 -35
DONEM34:		NOP								;                                 -34
DONEM33:		NOP								;                                 -33
DONEM32:		NOP								;                                 -32
DONEM31:		NOP								;                                 -31
DONEM30:		NOP								;                                 -30
DONEM29:		NOP								;                                 -29
DONEM28:		NOP								;                                 -28
DONEM27:		NOP								;                                 -27
DONEM26:		NOP								;                                 -26
DONEM25:		NOP								;                                 -25
DONEM24:		NOP								;                                 -24
DONEM23:		NOP								;                                 -23
DONEM22:		NOP								;                                 -22
DONEM21:		NOP								;                                 -21
DONEM20:		NOP								;                                 -20
DONEM19:		NOP								;                                 -19
DONEM18:		NOP								;                                 -18
DONEM17:		NOP								;                                 -17
DONEM16:		NOP								;                                 -16
DONEM15:		NOP								;                                 -15
DONEM14:		NOP								;                                 -14
DONEM13:		NOP								;                                 -13
DONEM12:		NOP								;                                 -12
DONEM11:		NOP								;                                 -11
DONEM10:		NOP								;                                 -10
DONEM9:			NOP								;                                 -9
DONEM8:			NOP								;                                 -8
DONEM7:			NOP								;                                 -7
DONEM6:			NOP								;                                 -6
DONEM5:			NOP								;                                 -5
DONEM4:			SBIC	PINF,INTFLG				;                                 -4, -3
				NOP;RCALL	KEYINT					; 
DONEM2:			SBIC	ACSR,ACI				;                                 -2
DONEM1:			NOP;SEI								;                                 -1
M1:				M1H[2]							; 2 
				BRCC	FROMRAM					; 3 /> 4
				M1L_ROM[13]						; 16
FROMRAM:		M1L_RAM[12]						; 16


DONEM3_:		RJMP	DONEM2_;1_				; -3, -2










DONEM80_:		NOP								;                                 -80
DONEM79_:		NOP								;                                 -79
DONEM78_:		NOP								;                                 -78
DONEM77_:		NOP								;                                 -77
DONEM76_:		NOP								;                                 -76
DONEM75_:		NOP								;                                 -75
DONEM74_:		NOP								;                                 -74
DONEM73_:		NOP								;                                 -73
DONEM72_:		NOP								;                                 -72
DONEM71_:		NOP								;                                 -71
DONEM70_:		NOP								;                                 -70
DONEM69_:		NOP								;                                 -69
DONEM68_:		NOP								;                                 -68
DONEM67_:		NOP								;                                 -67
DONEM66_:		NOP								;                                 -66
DONEM65_:		NOP								;                                 -65
DONEM64_:		NOP								;                                 -64
DONEM63_:		NOP								;                                 -63
DONEM62_:		NOP								;                                 -62
DONEM61_:		NOP								;                                 -61
DONEM60_:		NOP								;                                 -60
DONEM59_:		NOP								;                                 -59
DONEM58_:		NOP								;                                 -58
DONEM57_:		NOP								;                                 -57
DONEM56_:		NOP								;                                 -56
DONEM55_:		NOP								;                                 -55
DONEM54_:		NOP								;                                 -54
DONEM53_:		NOP								;                                 -53
DONEM52_:		NOP								;                                 -52
DONEM51_:		NOP								;                                 -51
DONEM50_:		NOP								;                                 -50
DONEM49_:		NOP								;                                 -49
DONEM48_:		NOP								;                                 -48
DONEM47_:		NOP								;                                 -47
DONEM46_:		NOP								;                                 -46
DONEM45_:		NOP								;                                 -45
DONEM44_:		NOP								;                                 -44
DONEM43_:		NOP								;                                 -43
DONEM42_:		NOP								;                                 -42
DONEM41_:		NOP								;                                 -41
DONEM40_:		NOP								;                                 -40
DONEM39_:		NOP								;                                 -39
DONEM38_:		NOP								;                                 -38
DONEM37_:		NOP								;                                 -37
DONEM36_:		NOP								;                                 -36
DONEM35_:		NOP								;                                 -35
DONEM34_:		NOP								;                                 -34
DONEM33_:		NOP								;                                 -33
DONEM32_:		NOP								;                                 -32
DONEM31_:		NOP								;                                 -31
DONEM30_:		NOP								;                                 -30
DONEM29_:		NOP								;                                 -29
DONEM28_:		NOP								;                                 -28
DONEM27_:		NOP								;                                 -27
DONEM26_:		NOP								;                                 -26
DONEM25_:		NOP								;                                 -25
DONEM24_:		NOP								;                                 -24
DONEM23_:		NOP								;                                 -23
DONEM22_:		NOP								;                                 -22
DONEM21_:		NOP								;                                 -21
DONEM20_:		NOP								;                                 -20
DONEM19_:		NOP								;                                 -19
DONEM18_:		NOP								;                                 -18
DONEM17_:		NOP								;                                 -17
DONEM16_:		NOP								;                                 -16
DONEM15_:		NOP								;                                 -15
DONEM14_:		NOP								;                                 -14
DONEM13_:		NOP								;                                 -13
DONEM12_:		NOP								;                                 -12
DONEM11_:		NOP								;                                 -11
DONEM10_:		NOP								;                                 -10
DONEM9_:		NOP								;                                 -9
DONEM8_:	 	NOP								;                                 -8
DONEM7_:		NOP								;                                 -7
DONEM6_:		NOP								;                                 -6
DONEM5_:		NOP								;                                 -5
DONEM4_:		SBIC	PINF,INTFLG				;                                 -4, -3
				NOP;RCALL	KEYINT					; 
DONEM2_:		SBIC	ACSR,ACI				;                                 -2
DONEM1_:		NOP;SEI								;                                 -1
M1_:			M1H[2]							; 2 
				BRCC	FROMRAM_				; 3 /> 4
				M1L_ROM[13]						; 16
FROMRAM_:		M1L_RAM_[12]					; 16






























KEYINT:			;SBIS	PINF,INTF11				; 
				;JMP		LOADER_					; 
				;JMP		STORER_					; 
				IN		TMPH,CONTROL
				SBR		TMPH,1<<SNDE
				OUT		CONTROL,TMPH
				CLI
				OUT		ACSR,ZERO			; DISABLE AC INTERRUPT             19
				SBI		ACSR,ACI			; RESET AC FLAG                    20
;WERQ:			SBIC	PINF,INTFLG
				;RJMP	WERQ
				RET



DELAY_1:		PUSH	BUF
				LDI		BUF,210					; DELAY FOR 20 kHz
LPDELAY1:		NOP
				NOP
				DEC		BUF
				BRNE	LPDELAY1
				POP		BUF
				RET


_INT:			;RJMP	INT_SERV			;
				SBIS	PINE,RBBCP			; 2
				RETI						; 
				MOV		CONST128,ZH			; 5
				MOV		ZERO,ZL				; 6
				POP		ZH					; 8
				POP		ZL					; 10
				PUSH	ZL					; 12
				PUSH	ZH					; 14
				SBIW	ZL,0X01				; 16
				PUSH	BUF					; 18
				IN		BUF,SREG			; 19
				PUSH	BUF					; 21
				BST		ZH,7				; 22
				BLD		BUF,0				; 23
				OUT		RAMPZ,BUF			; 24
				;CLC							; 25
				LSL		ZL					; 26
				ROL		ZH					; 27
				ELPM	BUF,Z+				; 30
				CPI		BUF,0XC3			; 31
				BRNE	OUTINT				; 32
				ELPM	BUF,Z				; 35
				CPI		BUF,0X94			; 36
				BREQ	INT_USTED			; 48
OUTINT:			MOV		ZL,ZERO				; 
				MOV		ZH,CONST128			; 
				LDI		CONST128,128		; 
				OUT		RAMPZ,ONE			; 
				CLR		ZERO				; 
				POP		BUF					; 
				OUT		SREG,BUF			; 
				POP		BUF					; 
				STS		TCNT3H,ZERO			; 
				STS		TCNT3L,ZERO			; 
				STS		TCCR3B,ONE			;
				RETI						; 

INT_USTED:		CLR		ZERO				; 48
				LDI		TMPH,128			; 50
				MOV		CONST128,TMPH		; 51
				LDI		BUF,0X01			; 52
				OUT		RAMPZ,BUF			; 53
INT_SERV:		nop							; 
				;call	liccodegen			; 56
				nop							; 
				LDI		TMPH,0XFF			; 57
				OUT		SPL,TMPH			; 58
				LDI		TMPH,0X10			; 59
				OUT		SPH,TMPH			; 60
				OUT		ACSR,ZERO			; 61
				SBI		ACSR,ACI			; 62
				IN		TMPH,CONTROL		; 63
				CBR		TMPH,(1<<IFF1)|(1<<IFF2);64
				OUT		CONTROL,TMPH		; 65
				SAVE_PC_SP[11]				; 76
				CBR		TMPH,0B11111100		; 77
				CPI		TMPH,0X02			; 78
				BRNE	IM0_1				; 79 /> 80
				RJMP	IM_2				; 81
IM0_1:			LDI		XH,0X00				; 82
				LDI		XL,0X38				; 83
				MOV		MEMPTRH,PCH			; 84
				MOV		MEMPTRL,PCL			; 85
				DEC		R					; 86
				LDI		TMPH,8				; N=8
IM0_1DELLOOP:	DEC		TMPH				; T=3*N=24
				BRNE	IM0_1DELLOOP		; 110
				RJMP	M1					; 112
IM_2:			LDI		ZL,0XFF				; 82
				IN		ZH,I				; 83
				CPI		ZH,0X40				; 84
				BRCC	FROMRAMIM_2_L		; 85 /> 86
				OR		ZH,ROMID			; 86
				ELPM	PCL,Z+				; 89
				NOP							; 90
				NOP							; 91
				RJMP	COMIM_2_1			; 93
FROMRAMIM_2_L:	XON_RBBCP					; 88
				LD		PCL,Z+				; 91
				XOFF_RBBCP					; 93
				OUT		RAMPZ,ONE			; ??
COMIM_2_1:		CPI		ZH,0X40				; 94
				BRCC	FROMRAMIM_2_H		; 95 /> 96
				OR		ZH,ROMID			; 96
				ELPM	PCH,Z+				; 99
				NOP							; 100
				NOP							; 101
				RJMP	COMIM_2_2			; 103
FROMRAMIM_2_H:	XON_RBBCP					; 98
				LD		PCH,Z+				; 101
				XOFF_RBBCP					; 103
COMIM_2_2:		OUT		RAMPZ,ONE			; ??
				MOV		MEMPTRH,PCH			; 104
				MOV		MEMPTRL,PCL			; 105
				DEC		R					; 106
				NOP							; 107
				NOP							; 108
				NOP							; 109				
				NOP							; 110 
				RJMP	M1					; 112


PRINT_BYTE:		PUSH	BUF					; 
				LDI		ZH,0X08				; 
				MOV		ZL,BUF				; 
				ANDI	ZL,0XF0				; 
				SWAP	ZL					; 
				LD		BUF,Z				; 
				CALL	KEYSND8				; 
				POP		ZL					; 
				ANDI	ZL,0X0F				; 
				LD		BUF,Z				; 
				CALL	KEYSND8				; 
				LDI		BUF,0X29			; 
				CALL	KEYSND8				; 
				RET							; 


SNDSTR:			;RET;OUT		RAMPZ,ONE
				;CPI		PCL,0X09
				;CPC		PCH,ZERO
				;BRCC	TRACEEN
				;RET						; 
				;IN		TMPH,CONTROL		; 
				;SBRS	TMPH,SNDE			; 
				;RET							; 
				
				;SBIC	PINF,INTFLG
				;ret				
				
				;LDI		ZH,0X0B
				;LDI		ZL,0X00
				;LD		TMPH,Z
				;CPI		TMPH,0X55
				;BREQ	TRACEEN
				
				
				;OUT		PORTE,ZERO			; RESET RBBCP                      37
				;STS		PORTF,ZERO			;   GENERATE INTERRUPT             39             2
				;LDI		TMPH,0XFF			;                                  40             3
				;OUT		PORTC,ZERO			; HIGH ADDR BYTE                   41             4
				;OUT		DDRC,TMPH			; !!! ADDR BUS IS HOLD ON !!!      42             5
				;STS		DDRF,ZERO			; HOLD OFF DATA BUS                44             7	
				;NOP							; NOP                              45             8
				;OUT		DDRC,ZERO			; --- ADDR BUS IS HOLD OFF ---     46             9
				;OUT		PORTE,CONST128		; SET RBBCP                        47            10
				;LDI		TMPH,1<<KEYMH		;                                  48            11
				;NOP							; NOP                              49            12
				;NOP							; NOP                              50            13
				;NOP							; NOP                              51            14
				;NOP							; NOP                              52            15
				;NOP							; NOP                              53            16
				;NOP							; NOP                              54            17
				;NOP							; NOP                              55            18
				;NOP							; NOP                              56            19
				;NOP							; NOP                              57            20
				;NOP							; NOP                              58            21
				;NOP							;                                  59            22
				;NOP							;                                  60            23
				;IN		TMPL,PINF			;                                  61            24
				;NOP							; SAVE FLAGS S, 5, 3               62
				;NOP							; FIRST  PARITY TABLE (WITH Z FLAG)63
				;NOP							; C REMAINS UNCHANGED              64
				;NOP							; READ FLAGS Z, H, P, N            66
				;NOP
				;NOP							; RESTORE C FLAG                   67
				;STS		PORTF,TMPH			;                                  69
				;STS		DDRF,TMPH			;                                  71
				;MOV		TMPH,TMPL
				;ANDI	TMPH,0B00011111		; 
				;CPI		TMPH,0B00011111
				;BRNE	SET55
				;RET


				;LDI		TMPH,0X99
				;CPI		XL,0X33
				;CPC		XH,TMPH
				;BREQ	tsttst
				;RET
;tsttst:			LDI		TMPH,0X95
				;CPI		E,0X0A
				;CPC		D,TMPH
				;BREQ	SET55
				;RET


;SET55:			LDI		ZH,0X0B
				;CLR		ZL
				;LDI		TMPH,0X55
				;ST		Z,TMPH

				
				
TRACEEN:		CLI							;
				OUT		ACSR,ZERO			; 
				SBI		ACSR,ACI			; 

TRACE:			PUSH 	BUF					; 
				;IN		BUF,CONTROL			; 
				;SBR		BUF,1<<SNDE			; 
				;OUT		CONTROL,BUF
				
				
;TRACE0:			MOVW	ZL,PCL				; 
				;CPI		ZH,0X40				; 
				;BRCS	FROMROMTR0			; 
				;XON_RBBCP					; 
				;LD		BUF,Z				; 
				;XOFF_RBBCP					; 
				;RJMP	TST10
;FROMROMTR0:		OR		ZH,ROMID			; 
				;ELPM	BUF,Z				; 
;TST10:			CPI		BUF,0X10
				;BRNE	TRCENABLED
				;RET








				
TRCENABLED:		MOVW	ZL,PCL				; 
				CALL	PRINT_WORD			; 
				MOVW	ZL,PCL				; 
				CPI		ZH,0X40				; 
				BRCS	FROMROMTR1			; 
				XON_RBBCP					; 
				LD		BUF,Z				; 
				XOFF_RBBCP					; 
				CALL	PRINT_BYTE			; 
				RJMP	TRACE2				; 
FROMROMTR1:		OR		ZH,ROMID			; 
				ELPM		BUF,Z				; 
				CALL	PRINT_BYTE			; 
TRACE2:			MOVW	ZL,PCL				; 
				ADIW	ZL,0X01				; 
				CPI		ZH,0X40				; 
				BRCS	FROMROMTR2			; 
				XON_RBBCP					; 
				LD		BUF,Z				; 
				XOFF_RBBCP					; 
				CALL	PRINT_BYTE			; 
				RJMP	TRACE3				; 
FROMROMTR2:		OR		ZH,ROMID			; 
				ELPM		BUF,Z				; 
				CALL	PRINT_BYTE			;
TRACE3:			MOVW	ZL,PCL				; 
				ADIW	ZL,0X02				; 
				CPI		ZH,0X40				; 
				BRCS	FROMROMTR3			; 
				XON_RBBCP					; 
				LD		BUF,Z				; 
				XOFF_RBBCP					; 
				CALL	PRINT_BYTE			; 
				RJMP	TRACE4				; 
FROMROMTR3:		OR		ZH,ROMID			; 
				ELPM		BUF,Z				; 
				CALL	PRINT_BYTE			; 
TRACE4:			MOVW	ZL,PCL				; 
				ADIW	ZL,0X03				; 
				CPI		ZH,0X40				; 
				BRCS	FROMROMTR4			; 
				XON_RBBCP					; 
				LD		BUF,Z				; 
				XOFF_RBBCP					; 
				CALL	PRINT_BYTE			; 
				RJMP	TRACE5				; 
FROMROMTR4:		OR		ZH,ROMID			; 
				ELPM		BUF,Z				; 
				CALL	PRINT_BYTE			; 
TRACE5:			MOVW	ZL,C				; 
				CALL	PRINT_WORD			; 
				MOVW	ZL,E				; 
				CALL	PRINT_WORD			; 
				MOVW	ZL,L				; 
				CALL	PRINT_WORD			; 
				MOV		ZL,F				;                                  18
				BST		ZL,1				;                                  19
				BLD		ZL,7				; COPY FLAG Z TO 7 POSITION        20
				BST		ZL,0				;                                  21
				BLD		ZL,1				; RETURN FLAG C TO 1 POSITION      22
				LSR		ZL					;                                  23
				CBR		ZL,(1<<7)|(1<<5)|(1<<3);                               24
				MOV		BUF,RES				;                                  25
				ANDI	BUF,(1<<7)|(1<<5)|(1<<3);                              26
				OR		ZL,BUF				;                                  27
				MOV		ZH,A				; 
				CALL	PRINT_WORD			; 
RJMP	TRACEEND
				MOV		ZH,IXH				; 
				MOV		ZL,IXL				; 
				CALL	PRINT_WORD			; 
				MOV		ZH,IYH				; 
				MOV		ZL,IYL				; 
				CALL	PRINT_WORD			; 
				MOVW	ZL,STPL				; 
				CALL	PRINT_WORD			; 
				IN		BUF,CONTROL			; 
				CALL	PRINT_BYTE			; 
				IN		BUF,PINB			; 
				CALL	PRINT_BYTE			; 
				IN		BUF,PIND			; 
				CALL	PRINT_BYTE			;  				
TRACEEND:		LDI		BUF,0X4C			; ";"
				CALL	KEYSND8				;
				MOV		BUF,ROMID			; 
				CALL	PRINT_BYTE			; 
				LDI		BUF,0X5A			; ENTER
				CALL	KEYSND8				; 
				POP		BUF					; 
				RET							; 


KEYSND8:		SBIC	PINE,KEYCLK					; TEST FOR HOST REQUEST
				RJMP	NORMOUT						; 
				SBI		PORTE,KEYCLK				; 1 SET
				SBI		DDRE,KEYCLK					; 1 KEYCLK
				CALL	DELAY_1						; 
				CALL	DELAY_1
				CBI		DDRE,KEYCLK					; 1 REALISE
				CBI		PORTE,KEYCLK				; 1 KEYCLK
				CALL	DELAY_1
				CALL	DELAY_1						; 
				RJMP	KEYSND8						; 
NORMOUT:		CBI		PORTE,KEYDATA				; 1 
				SBI		DDRE,KEYDATA				; 1 RESED DATA LINE
				SBI		PORTE,KEYCLK				; 2 SET
				SBI		DDRE,KEYCLK					; 2 CLK LINE
				CLR		TMPH						; CLEAR PARITET
				CALL	DELAY_1						; WAIT
				CBI		PORTE,KEYCLK				; RESET KEYCLK LINE
				CALL	DELAY_1						; WAIT
				SBI		PORTE,KEYCLK				; SET KEYCLK LINE
				CALL	DELAY_1						; WAIT
				RJMP	KEYSND81					; 	
KEYSND81:		
				MOV		TMPL,ONE					; 1 NUMBER OF BITS = 8
				LSL		TMPL						; 1 
				LSL		TMPL						; 1 
				LSL		TMPL						; 1 
LPSH8:			SBRS	BUF,0						; TEST FOR CURRENT BIT
				CBI		PORTE,KEYDATA				; RESET DATA LINE
				SBRC	BUF,0						; TEST FOR CURRENT BIT
				SBI		PORTE,KEYDATA				; SET DATA LINE
				SBRC	BUF,0						; TEST FOR PARITET
				INC		TMPH						; CORRECT PARITET
				CALL	DELAY_1						; WAIT
				CBI		PORTE,KEYCLK				; RESET KEYCLK LINE
				CALL	DELAY_1						; WAIT
				SBI		PORTE,KEYCLK				; SET KEYCLK LINE
				LSR		BUF							; PREPARE NEXT BIT
				DEC		TMPL						; COUNT BITS
				BRNE	LPSH8						; TEST FOR END OF BYTE
				INC		TMPH						; CORRECT PARITET
				SBRS	TMPH,0						; 3 
				CBI		PORTE,KEYDATA				; 3 
				SBRC	TMPH,0						; 3 PARITET
				SBI		PORTE,KEYDATA				; 3 BIT
				CALL	DELAY_1						; 3 
				CBI		PORTE,KEYCLK				; 3 
				CALL	DELAY_1						; 3 
				SBI		PORTE,KEYCLK				; 3 
				CALL	DELAY_1						; 3 
				SBI		PORTE,KEYDATA				; 4 
				CALL	DELAY_1						; 4 
				CBI		PORTE,KEYCLK				; 4 STOP BIT
				CALL	DELAY_1						; 4 SENDING
				SBI		PORTE,KEYCLK				; 4 
				CALL	DELAY_1						; 4
				LDI		BUF,0X80
				OUT		PORTE,BUF
				LDI		BUF,1<<RBBCP
				OUT		DDRE,BUF
				LDI		TMPH,0X36					; 5 
CALLD:			CALL	DELAY_1						; 5 DELAY BEFORE
				DEC		TMPH						; 5 RETURNING
				BRNE	CALLD						; 5 
				RET									; RETURN


PRINT_WORD:		PUSH	ZL					; 
				PUSH	ZL					; 
				PUSH	ZH					; 
				PUSH	ZH					; 
				LDI		ZH,0X08				; 
				POP		ZL					; 
				ANDI	ZL,0XF0				; 
				SWAP	ZL					; 
				LD		BUF,Z				; 
				CALL	KEYSND8				; 
				POP		ZL					; 
				ANDI	ZL,0X0F				; 
				LD		BUF,Z				; 
				CALL	KEYSND8				; 
				POP		ZL					; 
				ANDI	ZL,0XF0				; 
				SWAP	ZL					; 
				LD		BUF,Z				; 
				CALL	KEYSND8				; 
				POP		ZL					; 
				ANDI	ZL,0X0F				; 
				LD		BUF,Z				; 
				CALL	KEYSND8				; 
				LDI		BUF,0X29			; 
				CALL	KEYSND8				; 

				RET							; 














.INCLUDE "LOADER_STORER_128.inc"
;.INCLUDE "LOADER_STORER_48.inc"

.ORG	0XFE00
				JMP		RESET				; JUMP RESET 

.ORG	0XFE2E
				JMP		_INT				; JUMP TO INTERRUPT ROUTINE         6

.ORG	0XFE34
				JMP		_INT				; JUMP TO INTERRUPT ROUTINE         6




