;*****************************************************
;
;PORTB    7     6     5     4     3     2     1     0
;      ~RSTCS  CDIN   CS  CCLK DOUTCS 24MHZ  LRCK DOUTCS
;
;PORTD    7     6     5     4     3     2     1     0
;         -    CH6   CH5   CH4   CH3   CH2   CH1   CH0      
;
; CONTROL: 7 - BITE0
; CONTROL: 6 - BITF0

.include	"tn2313def.inc"
.include	"Regdef.inc"
.include	"Macroses.inc"
.include	"Vector_description.inc"
.include	"Subroutines.inc"
.include	"Initialization.inc"
		


		SEI                         			; 1 ENABLING INTERRUPTS
BEGSYN0:OUT		PORTD,INTDATA					; 1 
BEGSYNC:LDI		ST1,255							; 2 
TSTKS:	SBIS	PIND,KEYCLK						; 2 
		RJMP	BEGSYNC							; 2 
		NOP										; 2
		NOP										; 2		
		DEC		ST1								; 2 
		BRNE	TSTKS							; 2 


LOOPG:	SBIC	PIND,KEYCLK						; 3 
		RJMP	LOOPG							; 3 
		SBIC	PIND,KEYDATA					; 3 
		RJMP	BEGSYNC							; 3 
		CLR		DATA							; 3 
		LDI		ST1,0X08						; 3 
BITLOOP:LSR		DATA							; 3 
WKS11:	SBIS	PIND,KEYCLK						; 3 
		RJMP	WKS11							; 3 
WKS02:	SBIC	PIND,KEYCLK						; 3 
		RJMP	WKS02							; 3 INPUT DATA
		IN		BUF,PIND						; 3 
		SBRC	BUF,KEYDATA						; 3 
		SBR		DATA,0B10000000					; 3 
		DEC		ST1								; 3 
		BRNE	BITLOOP							; 3 

DTR:	CPI		DATA,0XF0						; 4 TEST FOR F0-PREFIX
		BRNE	NOTF0							; 4
		SBR		CONTROL,(1<<BITF0)				; 4 SET F0 BIT
		RJMP	BEGSYNC							; 4 RETURN TO MAIN LOOP

NOTF0:	CPI		DATA,0XE0						; 4 TEST FOR FO-PREFIX
		BRNE	NOTE0							; 4
		SBR		CONTROL,(1<<BITE0)				; 4 SET F0 BIT
		RJMP	BEGSYNC							; 4 RETURN TO MAIN LOOP
	
NOTE0:	SBRC	CONTROL,BITE0					; IF IT WAW E0
		RJMP	PREFE0							; E0-PREFIX CODE

		CPI		DATA,0X78						; 1 TEST FOR F11
		BRNE	NOTF11							; 1 
		RJMP	KF11							; 1
NOTF11:	CPI		DATA,0X07						; 1 TEST FOR F12
		BRNE	NOTF12							; 1 
		RJMP	KF12							; 1 

KF11:	SBRC	CONTROL,BITF0					; 2 TEST FOR F0 PREFIX OF F11
		RJMP	KF11OFF							; 2 
		SBR		INTDATA,(1<<INTFLG)|(1<<INTF11)	; 2 
		RJMP	BEGSYN0							; 2 RETURN TO MAIN LOOP
KF11OFF:CBR		INTDATA,(1<<INTFLG)|(1<<INTF11)	; 2 
		CBR		CONTROL,1<<BITF0				; 2 RESET F0 FLAG
		RJMP	BEGSYN0							; 2 RETURN TO MAIN LOOP

KF12:	SBRC	CONTROL,BITF0					; 3 TEST FOR F0 PREFIX OF F11
		RJMP	KF12OFF							; 3 
		SBR		INTDATA,(1<<INTFLG)|(1<<INTF12)	; 3 
		RJMP	BEGSYN0							; 3 RETURN TO MAIN LOOP
KF12OFF:CBR		INTDATA,(1<<INTFLG)|(1<<INTF12)	; 3 
		CBR		CONTROL,1<<BITF0				; 3 RESET F0 FLAG
BEGSNC1:RJMP	BEGSYN0							; 3 RETURN TO MAIN LOOP

		
		
NOTF12:	CPI		DATA,127						; 1
		BRGE	BEGSNC1							; 1
		MOV		ZL,DATA							; 1
		CLR		ZH								; 1
		LSL		ZL								; 1
		ADD		ZL,DATA							; 1 PREPARING ADDRERSS
		ADC		ZH,ZERO							; 1
		LDI		ST3,0X06						; 1
		LDI		ST2,0X80						; 1
		ADD		ZL,ST2							; 1
		ADC		ZH,ST3							; 1
		LPM		ST3,Z+							; 2 
		LPM		ST2,Z+							; 2 LOAD CODES FROM ROM
		LPM		ST1,Z							; 2 

LDRAM:	SBRC	CONTROL,BITF0					; 3 IF KEY HAS PUSHED OFF
		RJMP	KEYOFF							; 3 GO TO KEYOFF
		
KEYON:	COM		ST2								; 4 INVERSE 
		COM		ST1								; 4 CODE
		CLR		ZH								; 5 CLERAR XH
		



TSTC7:	SBRS	ST3,7							; 7 TEST FOR COLOMN 7 KEY
		RJMP	TSTC6							; 7 NOT COLOMN7 KEY
		AND		COLOMN7,ST2						; 8 CORRECT COLOMN7 REGISTER
		
TSTC6_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC6:	SBRS	ST3,6							; 7 TEST FOR COLOMN 6 KEY
		RJMP	TSTC5							; 7 NOT COLOMN6 KEY
		AND		COLOMN6,ST2						; 8 CORRECT COLOMN6 REGISTER


TSTC5_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC5:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,5							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TSTC4							; 7 NOT COLOMN5 KEY
LOOPC5:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TSTC4_							; 9 RAM CODE AREA
		SBRS	ZL,5							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	LOOPC5							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		AND		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	LOOPC5							; 1 LOOPING
	
TSTC4_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC4:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,4							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TSTC3							; 7 NOT COLOMN5 KEY
LOOPC4:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TSTC3_							; 9 RAM CODE AREA
		SBRC	ZL,4							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	LOOPC4							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		AND		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	LOOPC4							; 1 LOOPING

TSTC3_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC3:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,3							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TSTC2							; 7 NOT COLOMN5 KEY
LOOPC3:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TSTC2_							; 9 RAM CODE AREA
		SBRC	ZL,3							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	LOOPC3							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		AND		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	LOOPC3							; 1 LOOPING

TSTC2_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC2:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,2							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TSTC1							; 7 NOT COLOMN5 KEY
LOOPC2:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TSTC1_							; 9 RAM CODE AREA
		SBRC	ZL,2							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	LOOPC2							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		AND		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	LOOPC2							; 1 LOOPING

TSTC1_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC1:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,1							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TSTC0							; 7 NOT COLOMN5 KEY
LOOPC1:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TSTC0_							; 9 RAM CODE AREA
		SBRC	ZL,1							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	LOOPC1							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		AND		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	LOOPC1							; 1 LOOPING

TSTC0_:	MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TSTC0:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,0							; 7 TEST FOR COLOMN 5 KEY
LOOP1:	RJMP	BEGSYNC							; 7 LOOP
LOOPC0:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	LOOP1							; 9 RAM CODE AREA
		SBRC	ZL,0							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	LOOPC0							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		AND		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	LOOPC0							; 1 LOOPING


KEYOFF:	CLR		ZH								; 5 CLERAR XH
		CBR		CONTROL,(1<<BITF0)				; 5 CLEAR F0 BIT
	
TESTC7:	SBRS	ST3,7							; 7 TEST FOR COLOMN 7 KEY
		RJMP	TESTC6							; 7 NOT COLOMN7 KEY
		OR		COLOMN7,ST2						; 8 CORRECT COLOMN7 REGISTER
		
TESTC6_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC6:	SBRS	ST3,6							; 7 TEST FOR COLOMN 6 KEY
		RJMP	TESTC5							; 7 NOT COLOMN6 KEY
		OR		COLOMN6,ST2						; 8 CORRECT COLOMN6 REGISTER	
		
TESTC5_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC5:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,5							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TESTC4							; 7 NOT COLOMN5 KEY
CLOOP5:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TESTC4_							; 9 RAM CODE AREA
		SBRS	ZL,5							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	CLOOP5							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		OR		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	CLOOP5							; 1 LOOPING
	
TESTC4_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC4:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,4							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TESTC3							; 7 NOT COLOMN5 KEY
CLOOP4:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TESTC3_							; 9 RAM CODE AREA
		SBRC	ZL,4							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	CLOOP4							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		OR		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	CLOOP4							; 1 LOOPING

TESTC3_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC3:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,3							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TESTC2							; 7 NOT COLOMN5 KEY
CLOOP3:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TESTC2_							; 9 RAM CODE AREA
		SBRC	ZL,3							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	CLOOP3							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		OR		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	CLOOP3							; 1 LOOPING

TESTC2_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC2:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,2							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TESTC1							; 7 NOT COLOMN5 KEY
CLOOP2:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TESTC1_							; 9 RAM CODE AREA
		SBRC	ZL,2							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	CLOOP2							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		OR		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	CLOOP2							; 1 LOOPING

TESTC1_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC1:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,1							; 7 TEST FOR COLOMN 5 KEY
		RJMP	TESTC0							; 7 NOT COLOMN5 KEY
CLOOP1:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	TESTC0_							; 9 RAM CODE AREA
		SBRC	ZL,1							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	CLOOP1							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		OR		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	CLOOP1							; 1 LOOPING

TESTC0_:MOV		BUF,ST2							; * EXCHANGE
		MOV		ST2,ST1							; * ST2 WITH
		MOV		ST1,BUF							; * ST1	
TESTC0:	LDI		ZL,0X5F							; 6 PREPARING BEGINING RAM ADDRESS -1
		SBRS	ST3,0							; 7 TEST FOR COLOMN 5 KEY
LOOP2:	RJMP	BEGSYNC							; 7 LOOP
CLOOP0:	INC		ZL								; 8 NEXT RAM ADDRESS
		CPI		ZL,0XA0							; 9 TEST FOR END OF 
		BREQ	LOOP2							; 9 RAM CODE AREA
		SBRC	ZL,0							; 0 IS IT CURRENT COLOMN ADDRESS?
		RJMP	CLOOP0							; 0 NOT - LOOP
		LD		BUF,Z							; 1 LOAD RAM DATA
		OR		BUF,ST2							; 1 MAKING NEW CODE
		ST		Z,BUF							; 1 SAVING NEW CODE
		RJMP	CLOOP0							; 1 LOOPING										; 

PREFE0:	CBR		CONTROL,(1<<BITE0)				; CLERA E0 BIT
		CPI		DATA,0X5A						; ENTER [NUMPAD] ?
		BREQ	E05A							;	
		CPI		DATA,0X6B						; LEFT ?
		BREQ	E06B							;	
		CPI		DATA,0X72						; DOWN ?
		BREQ	E072							;	
		CPI		DATA,0X74						; RIGHT ?
		BREQ	E074							;	
		CPI		DATA,0X75						; UP ?
		BREQ	E075							;	
		CBR		CONTROL,(1<<BITF0)				;
		RJMP	BEGSYNC


E05A:	LDI		ST3,0X40						;
		LDI		ST2,0X01						;
		LDI		ST1,0X00						;
		RJMP	LDRAM							; 
E06B:	LDI		ST3,0X09						;
		LDI		ST2,0X10						;
		LDI		ST1,0X01						;
		RJMP	LDRAM							; 
E072:	LDI		ST3,0X11						;
		LDI		ST2,0X10						;
		LDI		ST1,0X01						;
		RJMP	LDRAM							; 
E074:	LDI		ST3,0X11						;
		LDI		ST2,0X20						;
		LDI		ST1,0X01						;
		RJMP	LDRAM							; 
E075:	LDI		ST3,0X11						;
		LDI		ST2,0X08						;
		LDI		ST1,0X01						;
		RJMP	LDRAM



SAVE:	LDI		YH,0X00
		LDI		YL,0X00
		LDI		ZH,0X00
		LDI		BUFI,0X01
		LDI		ZL,0X60
LPSAV:	LD		BUF,Z
		INC		ZL
		OUT		EEDR,BUF
		OUT		EEAR,YL
		SBI		EECR,EEMWE
		SBI		EECR,EEWE
WELP:	SBIC	EECR,EEWE
		RJMP	WELP
		ADD		YL,BUFI
		CPI		YL,0XA0
		BREQ	SSTP
		RJMP	LPSAV

SSTP:	RJMP	SSTP
		











.ORG	0X340
.DB		0X00, 0X00, 0X00,	0X00, 0X00, 0X00	; 00  " "   01 "F9"
.DB		0X00, 0X00, 0X00, 	0X80, 0X03, 0X00	; 02  " "   03 "F5"
.DB		0X84, 0X02, 0X01, 	0X09, 0X08, 0X01	; 04  "F3"  05 "F1"
.DB		0X41, 0X01, 0X01, 	0X00, 0X00, 0X00	; 06  "F2"  07 "F12"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 08  " "   09 "F10"
.DB		0X00, 0X00, 0X00, 	0X82, 0X02, 0X01	; 0A  "F8"  0B "F6"
.DB		0X05, 0X20, 0X01, 	0X00, 0X00, 0X00	; 0C  "F4"  0D "TAB"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 0E  "`"   0F " "

.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 10  " "           11 "ALT (L)"
.DB		0X01, 0X01, 0X00, 	0X00, 0X00, 0X00	; 12  "SHIFT (L)"   13 " "
.DB		0X00, 0X00, 0X00, 	0X04, 0X01, 0X00	; 14  "CTRL (L) "   15 "Q"
.DB		0X08, 0X01, 0X00, 	0X00, 0X00, 0X00	; 16  "1"           17 " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 18  " "  19 " "
.DB		0X01, 0X02, 0X00, 	0X02, 0X02, 0X00	; 1A  "Z"  1B "S"
.DB		0X02, 0X01, 0X00, 	0X04, 0X02, 0X00	; 1C  "A"  1D "W"
.DB		0X08, 0X02, 0X00, 	0X00, 0X00, 0X00	; 1E  "2"  1F " "

.DB		0X00, 0X00, 0X00, 	0X01, 0X08, 0X00	; 20  " "  21 "C"
.DB		0X01, 0X20, 0X00, 	0X02, 0X20, 0X00	; 22  "X"  23 "D"
.DB		0X04, 0X20, 0X00, 	0X08, 0X08, 0X00	; 24  "E"  25 "4"
.DB		0X08, 0X20, 0X00, 	0X00, 0X00, 0X00	; 26  "3"  27 " "
.DB		0X00, 0X00, 0X00,	0X80, 0X01, 0X00	; 28  " "  29 "SPACE"
.DB		0X01, 0X10, 0X00, 	0X02, 0X08, 0X00	; 2A  "V"  2B "F"
.DB		0X04, 0X10, 0X00, 	0X04, 0X08, 0X00	; 2C  "T"  2D "R"
.DB		0X08, 0X10, 0X00, 	0X00, 0X00, 0X00	; 2E  "5"  2F " "

.DB		0X00, 0X00, 0X00, 	0X80, 0X08, 0X00	; 30  " "  31 "N"
.DB		0X80, 0X10, 0X00, 	0X40, 0X10, 0X00	; 32  "B"  33 "H"
.DB		0X02, 0X10, 0X00, 	0X20, 0X10, 0X00	; 34  "G"  35 "Y"
.DB		0X10, 0X10, 0X00, 	0X00, 0X00, 0X00	; 36  "6"  37 " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 38  " "  39 " "
.DB		0X80, 0X20, 0X00, 	0X40, 0X08, 0X00	; 3A  "M"  3B "J"
.DB		0X20, 0X08, 0X00, 	0X10, 0X08, 0X00	; 3C  "U"  3D "7"
.DB		0X10, 0X20, 0X00, 	0X00, 0X00, 0X00	; 3E  "8"  3F " "

.DB		0X00, 0X00, 0X00, 	0X80, 0X0A, 0X00	; 40  " "  41 ","
.DB		0X40, 0X20, 0X00, 	0X20, 0X20, 0X00	; 42  "K"  43 "I"
.DB		0X20, 0X02, 0X00, 	0X10, 0X01, 0X00	; 44  "O"  45 "0"
.DB		0X10, 0X02, 0X00, 	0X00, 0X00, 0X00	; 46  "9"  47 " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 48  " "  49 " "
.DB		0X00, 0X00, 0X00, 	0X40, 0X02, 0X00	; 4A  "/"  4B "L"
.DB		0X88, 0X02, 0X02, 	0X20, 0X01, 0X00	; 4C  ";"  4D "P"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 4E  "-"  4F " "

.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 50  " "  51 " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 52  "'"  53 " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 54  "["  55 "+"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 56  " "  57 " "
.DB		0X09, 0X02, 0X01, 	0X80, 0X02, 0X00	; 58  "CAPS LOCK"          59 "SHIFT (R)"
.DB		0X40, 0X01, 0X00, 	0X00, 0X00, 0X00	; 5A  "ENTER, + [NUMPAD]"  5B "]"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 5C  " "  5D " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 5E  " "  5F " "

.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 60  " "           61 "\"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 62  " "           63 " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 64  " "           65 " "
.DB		0X11, 0X01, 0X01, 	0X00, 0X00, 0X00	; 66  "BACKSPACE"   67 " "
.DB		0X00, 0X00, 0X00, 	0X08, 0X01, 0X00	; 68  " "           69 "1 [NUMPAD]"
.DB		0X00, 0X00, 0X00, 	0X08, 0X08, 0X00	; 6A  " "           6B "4 [NUMPAD]"
.DB		0X10, 0X08, 0X00, 	0X00, 0X00, 0X00	; 6C  "7 [NUMPAD]"  6D " "
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 6E  " "           6F " "

.DB		0X10, 0X01, 0X00, 	0X00, 0X00, 0X00	; 70  "0 [NUMPAD]"  71 ". [NUMPAD]"
.DB		0X08, 0X02, 0X00, 	0X08, 0X10, 0X00	; 72  "2 [NUMPAD]"  73 "5 [NUMPAD]"
.DB		0X10, 0X10, 0X00, 	0X10, 0X20, 0X00	; 74  "6 [NUMPAD]"  75 "8 [NUMPAD]"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 76  "ESC"         77 "NUM LOCK"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 78  "F11"         79 " "
.DB		0X08, 0X20, 0X00, 	0X00, 0X00, 0X00	; 7A  "3 [NUMPAD]"  7B "- [NUMPAD]"
.DB		0X00, 0X00, 0X00, 	0X10, 0X02, 0X00	; 7C  "* [NUMPAD]"  7D "9 [NUMPAD]"
.DB		0X00, 0X00, 0X00, 	0X00, 0X00, 0X00	; 7E  "SCROLL LOCK" 7F " "





















